#include <Wire.h>
#include <Adafruit_MCP4725.h>
#include "IRremote.h"

// Variable DAC
int val_DAC=0;
const int DAC_Step=50;
const int DAC_Max=4095; // 2^12-1=4096-1=4095
Adafruit_MCP4725 dac;

// Numéro du pin sortie du récepteur 
long int res_val;
const int receiver = 11; 

// Déclaration d'un objet IRrecv
IRrecv irrecv(receiver);           
decode_results results;       

void setup(void) 
{
  // Initialisation DAC
  dac.begin(0x60);

  // Init du récepteur 
  irrecv.enableIRIn();
}

void loop(void)
{
  // Lecture de la télécommande 
  if (irrecv.decode(&results))
  {
    // Récupération du code   
    res_val = results.value;

    // Up PWM
    if (res_val==0xFF30CF)
    {
      val_DAC=val_DAC+DAC_Step; 
      if (val_DAC>DAC_Max) 
        val_DAC=0; 
    }

    // DOWN PWM
    if (res_val==0xFF18E7)
    {
      val_DAC=val_DAC-DAC_Step; 
      if (val_DAC<0) 
        val_DAC=DAC_Max; 
    }
     
    // Réception de la nouvelle valeur
    irrecv.resume();
  } 
  
  // Ecriture dans le DAC
  dac.setVoltage(val_DAC, false);
}
